// Application : ddFramework
// jhnApplication.prg , Created : 2014/12/09   09:54 PM
// User : Johan

#using jhnFT.Utils.Config
#using System.Windows.Forms

SEALED CLASS jhnApplication
	PROTECT nID AS INT
	PROTECT Name AS STRING
	PROTECT Text AS STRING

	CONSTRUCTOR(oPC AS jhnParameterCollection)
		SELF:InitializeApp(oPC)
	RETURN

	HIDDEN METHOD InitializeApp(oPC AS jhnParameterCollection) AS VOID
		STATIC iApp := 0 AS INT
		SELF:nID := oPC:GetInt("class_no")
		SELF:Name := oPC:Get("class_id")
		SELF:Text := oPC:Get("text")
		BEGIN SCOPE
			LOCAL aMbr AS jhnParameterCollection[]
			LOCAL aO AS OBJECT[]
			LOCAL cnt AS INT
			aO := jhnMemberInterface.Inst:MemberAdd(SELF:nID)
			IF (cnt := aO:Length - 1) < 0
				oPC:DisplayMembers("No members found")
			ENDIF
			FOR LOCAL i := 0 AS INT UPTO cnt
				IF aO[i]:GetType():IsSubclassOf(typeof(Form))
					BEGIN SCOPE
						LOCAL oForm AS Form
						oForm := (Form)aO[i]
						IF iApp++ = 0
							oForm:IsMdiContainer := TRUE
							oForm:StartPosition := FormStartPosition.CenterScreen
							oForm:ClientSize := System.Drawing.Size{250, 200}
//								oForm:WindowState := System.Windows.Forms.FormWindowState.Maximized
							Application.Run(oForm)
						ELSE
							oForm:Show()
						ENDIF
					END SCOPE
				ELSE
					MessageBox.Show(e"Unknown class member!\nExpecting a form\n\nObject type returned\t: " + aO[i]:GetType():ToString(), ;
											SELF:GetType():ToString() + ":InitializeApp()", MessageBoxButtons.OK, MessageBoxIcon.Error)
				ENDIF
			NEXT
		END SCOPE
	RETURN

END CLASS

