// Application : ddFramework
// jhnMemberInterface.prg , Created : 2014/11/24   06:51 PM
// User : Johan

#using jhnFT.Utils.Config
#using System.Reflection

DELEGATE MemAdd(o AS OBJECT) AS VOID

BEGIN NAMESPACE jhnFT.Utils.Config

	SEALED CLASS jhnMemberInterface
		STATIC HIDDEN _inst AS jhnMemberInterface

		STATIC CONSTRUCTOR()
			_inst := jhnMemberInterface{}
		RETURN

		HIDDEN CONSTRUCTOR()
			SUPER()
		RETURN

		STATIC PROPERTY Inst AS jhnMemberInterface
			GET
				RETURN _inst
			END GET
		END PROPERTY

		METHOD MemberAdd(oPC AS jhnParameterCollection) AS OBJECT
			LOCAL o AS OBJECT
			IF oPC:HasKey("defaultclass")
				BEGIN SCOPE
					LOCAL oAss AS Assembly
					LOCAL ctor AS ConstructorInfo
					LOCAL typ AS Type
					oAss := Assembly.GetAssembly(SELF:GetType())
					typ := oAss:GetType(oPC:Get("defaultclass"))
					ctor := typ:GetConstructor(<Type>{oPC:GetType()})
					o := ctor:Invoke(<OBJECT>{oPC})
				END SCOPE
			ELSE
				oPC:DisplayMembers("No default class specified")
			ENDIF
		RETURN o

		METHOD MemberAdd(oPC AS jhnParameterCollection, memadd AS MemAdd) AS VOID
			memadd(SELF:MemberAdd(oPC))
		RETURN

		METHOD MemberAdd(iCls AS INT) AS OBJECT[]
			LOCAL aMbr AS jhnParameterCollection[]
			LOCAL o AS System.Collections.Generic.List<OBJECT>
			o := System.Collections.Generic.List<OBJECT>{}
			aMbr := jhnSetupDict.Inst:ClassMemberGet(iCls)
			FOR LOCAL mbr := 0 AS INT UPTO aMbr:Length - 1
				o:Add(SELF:MemberAdd(aMbr[mbr]))
			NEXT
		RETURN o:ToArray()

		METHOD MemberAdd(iCls AS INT, memadd AS MemAdd) AS VOID
			LOCAL aO AS OBJECT[]
			LOCAL cnt AS INT
			aO :=  SELF:MemberAdd(iCls)
			cnt := aO:Length - 1
			FOR LOCAL i := 0 AS INT UPTO cnt
				memadd(aO[i])
			NEXT
		RETURN

	END CLASS

END NAMESPACE

