// Application : ddFramework
// jhnMenu.prg , Created : 2014/11/23   07:07 PM
// User : Johan

#using System.Windows.Forms
#using jhnFT.Utils.Config

CLASS jhnMenu INHERIT MenuStrip
	PROTECT nID AS INT

	CONSTRUCTOR(p AS jhnParameterCollection)
		SUPER()
		SELF:nID := p:GetInt("member_no")
		SELF:Name := p:Get("member_id")
		SELF:Text := p:Get("text")
		SELF:InitializeMenu()
	RETURN

	HIDDEN METHOD InitializeMenu() AS VOID
		LOCAL delMIAdd AS MemAdd
		LOCAL aMbr AS jhnParameterCollection[]
		delMIAdd := MemAdd{SELF, @MenuItemAdd()}
		TRY
			jhnMemberInterface.Inst:MemberAdd(SELF:nID, delMIAdd)
		CATCH ex AS Exception
			MessageBox.Show(ex:Message, SELF:GetType():ToString())
		END TRY
	RETURN

	HIDDEN METHOD MenuItemAdd(o AS OBJECT) AS VOID
		IF o:GetType():IsSubclassOf(typeof(MenuStrip))
			MessageBox.Show(e"Should not get here\n\nObject\t: " + o:GetType():ToString(), ;
									SELF:GetType():ToString() + ":MenuItemAdd(o) AS VOID")
		ELSEIF o:GetType():IsSubclassOf(typeof(ToolStripItem))
			SELF:Items:Add((ToolStripItem)o)
		ENDIF
	RETURN

END CLASS

